#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <math.h>
#include<complex.h>   

int main() {

/* declare complex variables */
float complex I_imag;
float complex z_cpl, zeta_cpl;
float complex W_zeta, W_z;
float complex Ia, zeta_mc;
float complex Ac, Bc, Cc;

int     i, Imax;
double  zeta_real, zeta_imag, z_real, z_imag;
double  R, theta, Dtheta, C_m, Cp;
double  Cm2_z, Cm2_zeta;
double Gamma, U_inf, alfa, alfar, U_mag, u_x, v_y;
const double C_x=-0.08, C_y=0.08;

C_m   = C_x*C_x+C_y*C_y;
alfa  = 0.0;
alfar = alfa*M_PI/180.0;
U_inf = 1.0;
R     =  sqrt(pow(1.0-C_x,2.0) + C_y*C_y) ;  
Gamma = 4.0*M_PI*U_inf*R*sin( alfar + asin( C_y/R ) );
 I_imag= 0.0 + 1.0*I;

Imax = 180;
Dtheta = 2.0*M_PI/Imax;
printf ("\n devide circle every %4.2f\t degrees \n \n" , Dtheta*180.0/M_PI);

/* the fprintf command Writes  "w" data on   file,
                       Appends "a" data on   file
                       Reads   "r" data from file */
FILE *fp1 = NULL;
FILE *fp2 = NULL;
FILE *fp3 = NULL;
fp1 = fopen ("zeta_plane.plt","w");
fp2 = fopen ("z_plane.plt","w");
fp3 = fopen ("Cp.plt","w");


for ( i=0; i<Imax; i++)
{
    theta = i*Dtheta;
/*zeta_cpl.real = C_x + R * cos( theta );
zeta_cpl.imag = C_y + R * sin( theta ); */
zeta_real = C_x + R * cos( theta );
zeta_imag = C_y + R * sin( theta );
zeta_cpl  = zeta_real + I_imag*zeta_imag; 
Cm2_zeta  = zeta_real*zeta_real + zeta_imag*zeta_imag;
fprintf (fp1,"%9.8f\t %9.8f\t%6.5f\n", zeta_real, zeta_imag);

 z_real = zeta_real*(Cm2_zeta + 1.0) ;
 z_imag = zeta_imag*(Cm2_zeta - 1.0) ; 

fprintf (fp2,"%9.8f\t %9.8f\t%6.5f\n", z_real, z_imag);
/*    printf ("%d\t %6.5f\t %6.5f\n", i, z_cpl.real, z_cpl.imag); */

      
   Ac      =zeta_real + zeta_imag*I;    
   Bc      =      0.0 +     alfar*I;    
   Cc      =      C_x +       C_y*I;    
   
   W_z=(U_inf*cexp(-Bc)+I_imag*Gamma/(2.0*M_PI*(Ac-Cc))  
       -U_inf*cexp( Bc)*pow(R,2.0)/cpowf(Ac-Cc,2.0 + 0.0*I))/(1.0-1.0/cpowf(Ac,2.0));

    
    u_x=creal(W_z); 
    v_y=cimag(W_z); 
    U_mag=sqrt(pow(u_x,2.0)+pow(v_y,2.0)); 
    Cp=1.0-pow(U_mag/U_inf,2.0);
fprintf (fp3," %10.8f\t %10.8f\t %10.8f\t \n", z_real, z_imag, -Cp); 
}
 close(fp1);
 close(fp2);
}
